/*
 * Board.h
 *
 *  Created on: Dec 2, 2020
 *      Author: elizabethcorrea
 */

#ifndef BOARD_H_
#define BOARD_H_

#define Board_CC26X2R1_LAUNCHXL

#ifdef __cplusplus
extern "C" {
#endif

#include <ti/drivers/Board.h>

#define Board_initGeneral()     Board_init()  /* deprecated */

#include "CC26X2R1_LAUNCHXL.h"

#define Board_shutDownExtFlash() CC26X2R1_LAUNCHXL_shutDownExtFlash()

#define Board_wakeUpExtFlash() CC26X2R1_LAUNCHXL_wakeUpExtFlash()

/* These #defines allow us to reuse TI-RTOS across other device families */

#define Board_ADC0              CC26X2R1_LAUNCHXL_ADC0
#define Board_ADC1              CC26X2R1_LAUNCHXL_ADC1

#define Board_ADCBUF0           CC26X2R1_LAUNCHXL_ADCBUF0
#define Board_ADCBUF0CHANNEL0   CC26X2R1_LAUNCHXL_ADCBUF0CHANNEL0
#define Board_ADCBUF0CHANNEL1   CC26X2R1_LAUNCHXL_ADCBUF0CHANNEL1

#define Board_ECDH0             CC26X2R1_LAUNCHXL_ECDH0
#define Board_ECDSA0            CC26X2R1_LAUNCHXL_ECDSA0
#define Board_ECJPAKE0          CC26X2R1_LAUNCHXL_ECJPAKE0
#define Board_AESCCM0           CC26X2R1_LAUNCHXL_AESCCM0
#define Board_AESGCM0           CC26X2R1_LAUNCHXL_AESGCM0
#define Board_AESCBC0           CC26X2R1_LAUNCHXL_AESCBC0
#define Board_AESCTR0           CC26X2R1_LAUNCHXL_AESCTR0
#define Board_AESECB0           CC26X2R1_LAUNCHXL_AESECB0
#define Board_AESCTRDRBG0       CC26X2R1_LAUNCHXL_AESCTRDRBG0
#define Board_SHA20             CC26X2R1_LAUNCHXL_SHA20
#define Board_TRNG0             CC26X2R1_LAUNCHXL_TRNG0

#define Board_DIO0              CC26X2R1_LAUNCHXL_DIO0
#define Board_DIO1_RFSW         CC26X2R1_LAUNCHXL_DIO1_RFSW
#define Board_DIO12             CC26X2R1_LAUNCHXL_DIO12
#define Board_DIO15             CC26X2R1_LAUNCHXL_DIO15
#define Board_DIO16_TDO         CC26X2R1_LAUNCHXL_DIO16_TDO
#define Board_DIO17_TDI         CC26X2R1_LAUNCHXL_DIO17_TDI
#define Board_DIO21             CC26X2R1_LAUNCHXL_DIO21
#define Board_DIO22             CC26X2R1_LAUNCHXL_DIO22

#define Board_DIO23_ANALOG      CC26X2R1_LAUNCHXL_DIO23_ANALOG
#define Board_DIO24_ANALOG      CC26X2R1_LAUNCHXL_DIO24_ANALOG
#define Board_DIO25_ANALOG      CC26X2R1_LAUNCHXL_DIO25_ANALOG
#define Board_DIO26_ANALOG      CC26X2R1_LAUNCHXL_DIO26_ANALOG
#define Board_DIO27_ANALOG      CC26X2R1_LAUNCHXL_DIO27_ANALOG
#define Board_DIO28_ANALOG      CC26X2R1_LAUNCHXL_DIO28_ANALOG
#define Board_DIO29_ANALOG      CC26X2R1_LAUNCHXL_DIO29_ANALOG
#define Board_DIO30_ANALOG      CC26X2R1_LAUNCHXL_DIO30_ANALOG

#define Board_GPIO_BUTTON0      CC26X2R1_LAUNCHXL_GPIO_S1
#define Board_GPIO_BUTTON1      CC26X2R1_LAUNCHXL_GPIO_S2
#define Board_GPIO_BTN1         CC26X2R1_LAUNCHXL_GPIO_S1
#define Board_GPIO_BTN2         CC26X2R1_LAUNCHXL_GPIO_S2
#define Board_GPIO_LED0         CC26X2R1_LAUNCHXL_GPIO_LED_RED
#define Board_GPIO_LED1         CC26X2R1_LAUNCHXL_GPIO_LED_GREEN
#define Board_GPIO_LED2         CC26X2R1_LAUNCHXL_GPIO_LED_RED
#define Board_GPIO_RLED         CC26X2R1_LAUNCHXL_GPIO_LED_RED
#define Board_GPIO_GLED         CC26X2R1_LAUNCHXL_GPIO_LED_GREEN
#define Board_GPIO_LED_ON       CC26X2R1_LAUNCHXL_GPIO_LED_ON
#define Board_GPIO_LED_OFF      CC26X2R1_LAUNCHXL_GPIO_LED_OFF
#define Board_GPIO_TMP116_EN    CC26X2R1_LAUNCHXL_GPIO_TMP116_EN

#define Board_GPTIMER0A         CC26X2R1_LAUNCHXL_GPTIMER0A
#define Board_GPTIMER0B         CC26X2R1_LAUNCHXL_GPTIMER0B
#define Board_GPTIMER1A         CC26X2R1_LAUNCHXL_GPTIMER1A
#define Board_GPTIMER1B         CC26X2R1_LAUNCHXL_GPTIMER1B
#define Board_GPTIMER2A         CC26X2R1_LAUNCHXL_GPTIMER2A
#define Board_GPTIMER2B         CC26X2R1_LAUNCHXL_GPTIMER2B
#define Board_GPTIMER3A         CC26X2R1_LAUNCHXL_GPTIMER3A
#define Board_GPTIMER3B         CC26X2R1_LAUNCHXL_GPTIMER3B

#define Board_I2C0              CC26X2R1_LAUNCHXL_I2C0
#define Board_I2C_TMP           Board_I2C0

#define Board_I2S0              CC26X2R1_LAUNCHXL_I2S0
#define Board_I2S_ADO           CC26X2R1_LAUNCHXL_I2S_ADO
#define Board_I2S_ADI           CC26X2R1_LAUNCHXL_I2S_ADI
#define Board_I2S_BCLK          CC26X2R1_LAUNCHXL_I2S_BCLK
#define Board_I2S_MCLK          CC26X2R1_LAUNCHXL_I2S_MCLK
#define Board_I2S_WCLK          CC26X2R1_LAUNCHXL_I2S_WCLK

#define Board_NVSINTERNAL       CC26X2R1_LAUNCHXL_NVSCC26XX0
#define Board_NVSEXTERNAL       CC26X2R1_LAUNCHXL_NVSSPI25X0

#define Board_PIN_BUTTON0       CC26X2R1_LAUNCHXL_PIN_BTN1
#define Board_PIN_BUTTON1       CC26X2R1_LAUNCHXL_PIN_BTN2
#define Board_PIN_BTN1          CC26X2R1_LAUNCHXL_PIN_BTN1
#define Board_PIN_BTN2          CC26X2R1_LAUNCHXL_PIN_BTN2
#define Board_PIN_LED0          CC26X2R1_LAUNCHXL_PIN_RLED
#define Board_PIN_LED1          CC26X2R1_LAUNCHXL_PIN_GLED
#define Board_PIN_LED2          CC26X2R1_LAUNCHXL_PIN_RLED
#define Board_PIN_RLED          CC26X2R1_LAUNCHXL_PIN_RLED
#define Board_PIN_GLED          CC26X2R1_LAUNCHXL_PIN_GLED

#define Board_PWM0              CC26X2R1_LAUNCHXL_PWM0
#define Board_PWM1              CC26X2R1_LAUNCHXL_PWM1
#define Board_PWM2              CC26X2R1_LAUNCHXL_PWM2
#define Board_PWM3              CC26X2R1_LAUNCHXL_PWM3
#define Board_PWM4              CC26X2R1_LAUNCHXL_PWM4
#define Board_PWM5              CC26X2R1_LAUNCHXL_PWM5
#define Board_PWM6              CC26X2R1_LAUNCHXL_PWM6
#define Board_PWM7              CC26X2R1_LAUNCHXL_PWM7

#define Board_SD0               CC26X2R1_LAUNCHXL_SDSPI0

#define Board_SPI0              CC26X2R1_LAUNCHXL_SPI0
#define Board_SPI1              CC26X2R1_LAUNCHXL_SPI1
#define Board_SPI_FLASH_CS      CC26X2R1_LAUNCHXL_SPI_FLASH_CS
#define Board_FLASH_CS_ON       0
#define Board_FLASH_CS_OFF      1

#define Board_SPI_MASTER        CC26X2R1_LAUNCHXL_SPI0
#define Board_SPI_SLAVE         CC26X2R1_LAUNCHXL_SPI0
#define Board_SPI_MASTER_READY  CC26X2R1_LAUNCHXL_SPI_MASTER_READY
#define Board_SPI_SLAVE_READY   CC26X2R1_LAUNCHXL_SPI_SLAVE_READY

#define Board_UART0             CC26X2R1_LAUNCHXL_UART0
#define Board_UART1             CC26X2R1_LAUNCHXL_UART1

#define Board_WATCHDOG0         CC26X2R1_LAUNCHXL_WATCHDOG0

#ifdef __cplusplus
}
#endif



#endif /* BOARD_H_ */
