/* XDC Module Headers */
#include <xdc/std.h>
#include <xdc/runtime/System.h>

/* BIOS Module Headers */
#include <ti/sysbios/BIOS.h>
#include <ti/drivers/GPIO.h>
#include <ti/drivers/SPI.h>
#include <unistd.h>

/* Example/Board Header files */
#include "Board.h"

#include <stdint.h>
#include <stddef.h>
#include <stdio.h>
#include <ti/drivers/PIN.h>
#include "ti_drivers_config.h"

#include <ti/display/Display.h>
static Display_Handle display;
/*
 *  ======== main ========
 */
void *mainThread(void *arg0)
{

    SPI_Handle      spi;
    SPI_Params      spiParams;
    SPI_Transaction spiTransaction;
    int x;
    float baseline;
    float sum;
    int16_t        result;
    uint16_t        txBuffer[1];
    uint16_t        rxBuffer[1];
    bool            transferOK = FALSE;
    float           voltage;

    /* Call driver init functions */
    //Board_initGeneral();
    //ledPinHandle = PIN_open(&ledPinState, spipins);
    Display_init();
    GPIO_init();
    SPI_init();
    SPI_Params_init(&spiParams);
    spiParams.dataSize = 16;
    //spiParams.bitRate = 400000;
    //spiParams.frameFormat = SPI_POL0_PHA0;
    //spiParams.mode = SPI_MASTER;

    /* Open the UART display for output */
        display = Display_open(Display_Type_UART, NULL);
        if (display == NULL) {
            while (1);
        }
    GPIO_setConfig(CONFIG_SPI_MASTER_READY, GPIO_CFG_OUTPUT | GPIO_CFG_OUT_LOW);

    spi = SPI_open(CONFIG_SPI_MASTER, &spiParams);

    GPIO_write(CONFIG_SPI_MASTER_READY, 0);

    if (spi == NULL){
        Display_printf(display, 0, 0, "SPI_open failed!\n");
    }
    else{
        Display_printf(display, 0, 0, "Starting the SPI transfer\n");
    }
    sleep(1);
int i;
sum = 0;
//once this is configured have this set to be continuous using while loop,
    //have another variable hold the old value of the data set and compare the two

Display_printf(display, 0, 0, "Starting the baseline test \n");

for(i = 0;i <500;i++){
    //transmitBuffer[2] = 0x52;
txBuffer[0] = 0x0000;

    spiTransaction.txBuf = txBuffer;
    spiTransaction.rxBuf = rxBuffer;
    spiTransaction.count = 1;

    transferOK = SPI_transfer(spi, &spiTransaction);
     if (!transferOK) {
         Display_printf(display, 0, 0, "Error in transaction process\n");
      }
        x = rxBuffer[0];

    //result = (retval[0]);
    result = x >> 1;

    result = result & 0b0000111111111111;

    voltage = ((float)(result*(3.3*0.000244)));

    sum = (float)(sum + voltage);

    sleep(1);
}

Display_printf(display, 0, 0, "sum = [%f] \n", sum);

baseline = (float)(sum*0.002);

Display_printf(display, 0, 0, "baseline is [%f] \n", baseline);

for(i = 0; i < 50; i++){
    txBuffer[0] = 0x0000;

        spiTransaction.txBuf = txBuffer;
        spiTransaction.rxBuf = rxBuffer;
        spiTransaction.count = 1;

        transferOK = SPI_transfer(spi, &spiTransaction);
         if (!transferOK) {
             Display_printf(display, 0, 0, "Error in transaction process\n");
          }
            x = rxBuffer[0];
            Display_printf(display, 0, 0, "%x, %x \n", x, rxBuffer[0]);



        //result = (retval[0]);
        result = x >> 1;
        Display_printf(display, 0, 0, "%x \n", result);
        result = result & 0b0000111111111111;


        Display_printf(display, 0, 0, "%x \n", result);

        voltage = ((float)(result*(3.3*0.000244)));

        Display_printf(display, 0, 0, "[%f] \n", voltage);

        if((float)(voltage - baseline)>0.3){
            Display_printf(display, 0, 0, "Stress detected! \n", result);
        }

        sleep(1);
}
/*
 * make another int16_t oldResult, possibly have another variable i or something to ensure the continuous loop
 * has occurred more than once, then compare oldresult to new result
 *
 * if(i > 0){
 * if((result - oldResult) > #){ //still looking into finding this number
 * Run stress protocol (alert of stress)
 * }
 *
 *
 */
/*
for(i = 0;i <5;i++){
    //transmitBuffer[2] = 0x52;
txBuffer[0] = 0x0000;

    spiTransaction.txBuf = txBuffer;
    spiTransaction.rxBuf = rxBuffer;
    spiTransaction.count = 1;

    transferOK = SPI_transfer(spi, &spiTransaction);
     if (!transferOK) {
         Display_printf(display, 0, 0, "Error in transaction process\n");
      }
        x = rxBuffer[0];
        Display_printf(display, 0, 0, "%x, %x \n", x, rxBuffer[0]);



    //result = (retval[0]);
    result = x >> 1;
    Display_printf(display, 0, 0, "%x \n", result);
    result = result & 0b0000111111111111;


    Display_printf(display, 0, 0, "%x \n", result);

    voltage = ((float)(result*(3.3*0.000244)));

    Display_printf(display, 0, 0, "[%f] \n", voltage);

}

Display_printf(display, 0, 0, "sum = %x \n", sum);

baseline = sum*0.02;

Display_printf(display, 0, 0, "baseline is %x \n", baseline);
*/
/*
txBuffer[0] = 0x0000;

    spiTransaction.txBuf = txBuffer;
    spiTransaction.rxBuf = rxBuffer;
    spiTransaction.count = 1;

    transferOK = SPI_transfer(spi, &spiTransaction);
     if (!transferOK) {
         Display_printf(display, 0, 0, "Error in transaction process\n");
      }
        x = rxBuffer[0];
        Display_printf(display, 0, 0, "%x, %x \n", x, rxBuffer[0]);



    //result = (retval[0]);
    result = x >> 1;
    Display_printf(display, 0, 0, "%x \n", result);
    result = result & 0b0000111111111111;


    Display_printf(display, 0, 0, "%x \n", result);



    voltage = ((float)(result*(3.3*0.000244)));

    Display_printf(display, 0, 0, "[%f] \n", voltage);
*/
SPI_close(spi);



    return(NULL);
}




//const PIN_Config BoardGpioInitTable[] = {

  //  CC2640R2_LAUNCHXL_PIN_RLED | PIN_GPIO_OUTPUT_EN | PIN_GPIO_LOW | PIN_PUSHPULL | PIN_DRVSTR_MAX,       /* LED initially off */
//    CC2640R2_LAUNCHXL_PIN_GLED | PIN_GPIO_OUTPUT_EN | PIN_GPIO_LOW | PIN_PUSHPULL | PIN_DRVSTR_MAX,       /* LED initially off */
  //  CC2640R2_LAUNCHXL_PIN_BTN1 | PIN_INPUT_EN | PIN_PULLUP | PIN_IRQ_BOTHEDGES | PIN_HYSTERESIS,          /* Button is active low */
    //CC2640R2_LAUNCHXL_PIN_BTN2 | PIN_INPUT_EN | PIN_PULLUP | PIN_IRQ_BOTHEDGES | PIN_HYSTERESIS,          /* Button is active low */
    //CC2640R2_LAUNCHXL_SPI_FLASH_CS | PIN_GPIO_OUTPUT_EN | PIN_GPIO_HIGH | PIN_PUSHPULL | PIN_DRVSTR_MIN,  /* External flash chip select */
 //   CC2640R2_LAUNCHXL_UART_RX | PIN_INPUT_EN | PIN_PULLDOWN,                                              /* UART RX via debugger back channel */
 //   CC2640R2_LAUNCHXL_UART_TX | PIN_GPIO_OUTPUT_EN | PIN_GPIO_HIGH | PIN_PUSHPULL,                        /* UART TX via debugger back channel */
 //   CC2640R2_LAUNCHXL_SPI0_MOSI | PIN_INPUT_EN | PIN_PULLUP,                                            /* SPI master out - slave in */
 //   CC2640R2_LAUNCHXL_SPI0_MISO | PIN_INPUT_EN | PIN_PULLDOWN,                                            /* SPI master in - slave out */
 //   CC2640R2_LAUNCHXL_SPI0_CLK | PIN_INPUT_EN | PIN_PULLDOWN,                                             /* SPI clock */
 //   CC2640R2_LAUNCHXL_SPI0_CSN | PIN_INPUT_EN | PIN_PULLDOWN,

 //   PIN_TERMINATE
//};
