unfinishedTail = [];
accelStream = [];
edaStream = [];
adcStream = [];
pulseStream = [];

pulseSampleSize = 24; %size (in bytes) of each pulse oximeter sample (timestamp+sample)

% fileID = fopen('D:\Downloads\MATLABcodes\allSensors.bin');
% fileID = fopen('D:\Downloads\MATLABcodes\micADC2.bin');
% fileID = fopen('D:\Downloads\MATLABcodes\ecgADC1.bin');
% fileID = fopen('D:\Downloads\MATLABcodes\ecgADC2.bin');
% fileID = fopen('D:\Downloads\MATLABcodes\eda-accel.bin');
% fileID = fopen('D:\Downloads\MATLABcodes\good_accel.bin');
% fileID = fopen('D:\Downloads\MATLABcodes\good-ecg-ble.bin');
fileID = fopen('D:\Downloads\MATLABcodes\good-mic-ble.bin');
% fileID = fopen('D:\Downloads\MATLABcodes\test1 - Copy.bin');
% fileID = fopen('D:\Downloads\MATLABcodes\test1.bin');
A = fread(fileID, 'uint8');


% tiledlayout(4,4) % Requires R2019b or later

h = dec2hex(A);
if(isempty(unfinishedTail) ) %if there's not data in the unfinished tail (new message?)
	firstHeadIndex = 1;
    while(~strcmp(h(firstHeadIndex,:),'04')) %while the first byte is not '04'
    	firstHeadIndex = firstHeadIndex + 1; %increment the index
    end
    h = h(firstHeadIndex:end, :); %h = everything starting after the '04' byte
end

[accelStream,edaStream,adcStream,pulseStream,unfinishedTail] = parseLiveLogWHM(unfinishedTail, h);

if(~isempty(accelStream)) %if there's any accelerometer data
%parse the accel stream
    accelRawTimesHex = [accelStream(2:8:length(accelStream),:), accelStream(1:8:length(accelStream)-1,:)]; %times in hex are the first 4 bytes of each message, order is flipped and it repeats every 8 values
    accelRawTimesDec = hex2dec(accelRawTimesHex);
    accelZeroedTimesDec = accelRawTimesDec - accelRawTimesDec(1:1); %remove offset (first sample t = 0)
    accelElapsedSeconds = accelZeroedTimesDec * 10E-6; %convert time to seconds
    accelXHex = [accelStream(4:8:length(accelStream),:), accelStream(3:8:length(accelStream)-1,:)]; %accelX values in hex are the second 4 bytes of each message, order is flipped and it repeats every 8 values
    accelXDec = typecast(uint32(hex2dec(accelXHex)),'single'); %need to convert to single precision floating point cause that's what our hardware supports
    accelYHex = [accelStream(6:8:length(accelStream),:), accelStream(5:8:length(accelStream)-1,:)]; %accelY values in hex are the third 4 bytes of each message, order is flipped and it repeats every 8 values
    accelYDec = typecast(uint32(hex2dec(accelYHex)),'single'); %need to convert to single precision floating point cause that's what our hardware supports
    accelZHex = [accelStream(8:8:length(accelStream),:), accelStream(7:8:length(accelStream)-1,:)]; %accelZ values in hex are the fourth 4 bytes of each message, order is flipped and it repeats every 8 values
    accelZDec = typecast(uint32(hex2dec(accelZHex)),'single'); %need to convert to single precision floating point cause that's what our hardware supports
    accelXTimeDec = [accelElapsedSeconds accelXDec]; %time and x together

%     nexttile
    figure
    plot(accelElapsedSeconds, accelXDec, accelElapsedSeconds, accelYDec, accelElapsedSeconds, accelZDec);
    title('Acceleration over Time');
    legend('X axis', 'Y axis', 'Z axis');
    xlabel('Elapsed Time (seconds)');
    ylabel('Acceleration (g)');
    %set axis limits based on the specific data we received
    xlim([10 35]);
    ylim([-1.5 2.25]);
end

if(~isempty(edaStream)) %if there's any eda data
    %parse EDA stream
    edaRawTimesHex = [edaStream(2:4:length(edaStream),:), edaStream(1:4:length(edaStream)-1,:)]; %times in hex are the first 4 bytes of each message, but order needs to be flipped
    edaRawTimesDec = hex2dec(edaRawTimesHex); %convert to dec
    edaZeroedTimesDec = edaRawTimesDec - edaRawTimesDec(1:1); %remove offset (first sample t = 0)
    edaElapsedSeconds = edaZeroedTimesDec * 10E-6; %convert time to seconds
    edaVoltsHex = [edaStream(4:4:length(edaStream),:), edaStream(3:4:length(edaStream)-1,:)]; %voltage is hex are the next 4 bytes of each message, once again byte flipped
    edaVoltsDec = typecast(uint32(hex2dec(edaVoltsHex)),'single'); %need to convert to single precision floating point cause that's what our hardware supports
    edaSplitDec = [edaElapsedSeconds edaVoltsDec]; %combine the times and voltages into one array
    
%     nexttile
%     plot(edaElapsedSeconds, edaVoltsDec);
%     title('EDA Voltage over Time');
%     legend('EDA');
    
    figure
    plot(edaElapsedSeconds, edaVoltsDec);
    title('EDA Voltage over Time');
    legend('EDA Voltage');
    xlabel('Elapsed Time (seconds)');
    ylabel('EDA Voltage (volts)');
end

if(~isempty(adcStream)) %if there's any adc data
    %parse ADC stream
    adcRawTimesHex = [adcStream(2:6:length(adcStream),:), adcStream(1:6:length(adcStream)-1,:)];%times in hex are the first 4 bytes of each message, but order needs to be flipped. Repeats every 6 values
    adcRawTimesDec = hex2dec(adcRawTimesHex); %convert to dec
    adcZeroedTimesDec = adcRawTimesDec - adcRawTimesDec(1:1); %zero out, so first sample t = 0
    adcElapsedSeconds = adcZeroedTimesDec * 10E-6; %convert to seconds of elapsed time
    micMicrovoltsHex = [adcStream(4:6:length(adcStream),:), adcStream(3:6:length(adcStream)-1,:)];
    micMicrovoltsDec = hex2dec(micMicrovoltsHex);
    micVoltsDec = micMicrovoltsDec / 1E6;
    ecgMicrovoltsHex = [adcStream(6:6:length(adcStream),:), adcStream(5:6:length(adcStream)-1,:)]; %ecg values in hex are the second 4 bytes of each message, order is flipped and it repeats every 6 values
    ecgMicrovoltsDec = hex2dec(ecgMicrovoltsHex);
    ecgVoltsDec = ecgMicrovoltsDec / 1E6;

    
%     nexttile
%     plot(adcElapsedSeconds, ecgVoltsDec);
%     title('ECG Voltage over time');
%     legend('ECG');
%     
%     nexttile
%     plot(adcElapsedSeconds, micVoltsDec);
%     title('Mic Voltage over time');
%     legend('Mic');
    
    figure
    plot(adcElapsedSeconds, micVoltsDec);
    title('Microphone ADC Voltage over Time');
    legend('Mic');
    xlabel('Elapsed Time (Seconds)');
    ylabel('Mic ADC Voltage (Volts)');
    
    figure
    plot(adcElapsedSeconds, ecgVoltsDec);
    title('ECG ADC Voltage over Time');
    legend('ECG');
    xlabel('Elapsed Time (Seconds)');
    ylabel('ECG ADC Voltage (Volts)');
    xlim([132.5 135]);
end
    
if(~isempty(pulseStream)) %if there's any pulse oximeter data
    %parse pulse oximeter data
    
    if(rem(length(pulseStream),pulseSampleSize) ~= 0) %if we don't have a multiple of the sample
        
    end
%     pulseInts = [pulseStream(8:pulseSampleSize:length(pulseStream),:), pulseStream(7:pulseSampleSize:length(pulseStream),:),pulseStream(6:pulseSampleSize:length(pulseStream),:),pulseStream(5:pulseSampleSize:length(pulseStream),:), pulseStream(4:pulseSampleSize:length(pulseStream),:), pulseStream(3:pulseSampleSize:length(pulseStream),:), pulseStream(2:pulseSampleSize:length(pulseStream),:), pulseStream(1:pulseSampleSize:length(pulseStream),:)];
%     pulseInts = [pulseStream(1:pulseSampleSize:length(pulseStream),:), pulseStream(2:pulseSampleSize:length(pulseStream)-1,:), pulseStream(3:pulseSampleSize:length(pulseStream)-2,:), pulseStream(4:pulseSampleSize:length(pulseStream)-3,:), pulseStream(5:pulseSampleSize:length(pulseStream)-4,:), pulseStream(6:pulseSampleSize:length(pulseStream)-5,:), pulseStream(7:pulseSampleSize:length(pulseStream)-6,:), pulseStream(8:pulseSampleSize:length(pulseStream)-7,:), pulseStream(9:pulseSampleSize:length(pulseStream)-8,:), pulseStream(10:pulseSampleSize:length(pulseStream)-9,:), pulseStream(11:pulseSampleSize:length(pulseStream)-10,:), pulseStream(12:pulseSampleSize:length(pulseStream)-11,:), pulseStream(13:pulseSampleSize:length(pulseStream)-12,:), pulseStream(14:pulseSampleSize:length(pulseStream)-13,:), pulseStream(15:pulseSampleSize:length(pulseStream)-14,:), pulseStream(16:pulseSampleSize:length(pulseStream)-15,:)];
%     pulseInts = [pulseStream(1:pulseSampleSize:length(pulseStream),:), pulseStream(2:pulseSampleSize:length(pulseStream),:), pulseStream(3:pulseSampleSize:length(pulseStream),:), pulseStream(4:pulseSampleSize:length(pulseStream),:)];
    
    termChar = pulseStream(24:24,:); %termination char at the end of every 

    pulseTimesRawHex = [pulseStream(4:pulseSampleSize:length(pulseStream),:), pulseStream(3:pulseSampleSize:length(pulseStream),:), pulseStream(2:pulseSampleSize:length(pulseStream),:), pulseStream(1:pulseSampleSize:length(pulseStream),:)];
    pulseTimesRawDec = hex2dec(pulseTimesRawHex); %convert to dec
    pulseTimesRawDec(1:1);
    pulseTimesZeroedDec = pulseTimesRawDec - pulseTimesRawDec(1:1);
    pulseTimesElapsedSeconds = pulseTimesZeroedDec * 10E-6;

%     pulseRawTimesHex = [pulseStream(4:28:length(pulseStream),:), pulseStream(3:28:length(pulseStream)-1,:), pulseStream(2:28:length(pulseStream)-2,:), pulseStream(1:28:length(pulseStream)-3,:)];
%     pulseRawTimesDec = hex2dec(pulseRawTimesHex); %convert to dec
%     pulseZeroedTimesDec = pulseRawTimesDec - pulseRawTimesDec(1:1);
%     pulseElapsedSeconds = pulseZeroedTimesDec * 10E-6;
%     pulseIrLedHex = [pulseStream(8:28:length(pulseStream)-4,:), pulseStream(7:28:length(pulseStream)-5,:), pulseStream(6:28:length(pulseStream)-6,:), pulseStream(5:28:length(pulseStream)-7,:)];
%     pulseIrLedDec = hex2dec(pulseIrLedHex);
%     pulseRedLedHex = [pulseStream(12:28:length(pulseStream)-14,:), pulseStream(11:28:length(pulseStream)-15,:), pulseStream(10:28:length(pulseStream)-16,:), pulseStream(9:28:length(pulseStream)-17,:)];
%     pulseRedLedDec = hex2dec(pulseRedLedHex);
%     pulseHeartRateHex = [pulseStream(14:28:length(pulseStream)-18,:), pulseStream(13:28:length(pulseStream)-19,:)];
%     pulseHeartRateDec = hex2dec(pulseHeartRateHex);
%     pulseHeartConfHex = pulseStream(15:28:length(pulseStream)-20,:);
%     pulseHeartConfDec = hex2dec(pulseHeartConfHex);
%     pulseOxygenHex = [pulseStream(18:28:length(pulseStream)-21,:), pulseStream(17:28:length(pulseStream)-22,:)]; %weird indexing because byte alignment in this hardware
%     pulseOxygenDec = hex2dec(pulseOxygenHex);
%     pulseStatusHex = pulseStream(18:28:length(pulseStream)-23,:);
%     pulseStatusDec = hex2dec(pulseStatusHex);
%     pulseRValueHex = [pulseStream(24:28:length(pulseStream)-24,:), pulseStream(23:28:length(pulseStream)-25,:), pulseStream(22:28:length(pulseStream)-26,:), pulseStream(21:28:length(pulseStream)-27,:)];
%     pulseRValueDec = typecast(uint32(hex2dec(pulseRValueHex)),'single'); %need to convert to single precision floating point cause that's what our hardware supports
%     pulseExtStatusHex = pulseStream(25:28:length(pulseStream)-28,:);
%     pulseExtStatusDec = hex2dec(pulseExtStatusHex);

%     figure
%     plot(pulseIrLedDec);
    
%     nexttile
%     figure
%     plot(pulseTimesElapsedSeconds, pulseIrLedDec);
%     title('IR LED Count over Time');
%     legend('IR LED Count');
end

